//+------------------------------------------------------------------+
//|                                                 ProBoy XonaX.mq4 |
//|                                        Copyright 2015, Xonax.ru. |
//|                                             https://www.xonax.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, Xonax.ru."
#property link      "https://www.xonax.ru"
#property version   "1.00"
#property strict
//--- input parameters
input int      StLoss=70000;
//---    1     ,     
input int      TProf=50;
input int      TimeFr=60; //      
input double   Lot=0.05;
input int      Magik=100004;
extern string  optime = "09-03;10-03;11-03;12-03;13-03;14-03"; //    -   ";"
extern string  closetime = "09-40;10-40;11-40;12-40;13-40;14-40"; //    -   ";"
string arrtime[]; string arrtime2[]; string comm;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   double Dmax,Dmin; bool tradetime = false; comm = "\n"; bool closeneed = false;
   static datetime BarT=0; //  ,
   datetime TempT; //    1         
   int total=OrdersTotal();
   Dmax=iOpen(NULL,TimeFr,2); // Open  
   Dmin=iClose(NULL,TimeFr,2); // Close  
   TempT=iTime(NULL,TimeFr,0); //   
   
   ushort u_sep=StringGetCharacter(";",0);
   ushort u_sep2=StringGetCharacter("-",0);
   
   int k=StringSplit(optime,u_sep,arrtime); // arrtime  
   for(int a=ArrayRange(arrtime,0); a>0; a--){
      comm = comm+arrtime[a-1]+"\n";
      string tm[];
      int k2=StringSplit(arrtime[a-1],u_sep2,tm);
      if(Hour()==StringToInteger(tm[0]) && Minute()==StringToInteger(tm[1])){
         tradetime = true;
         comm = comm + "  !!!! "+Hour()+" : "+Minute()+"\n";
      }
   }
   
   int k3=StringSplit(closetime,u_sep,arrtime2); // arrtime2   
   for(int a2=ArrayRange(arrtime2,0); a2>0; a2--){
      comm = comm+arrtime2[a2-1]+"\n";
      string tm2[];
      int k3=StringSplit(arrtime2[a2-1],u_sep2,tm2);
      if(Hour()==StringToInteger(tm2[0]) && Minute()==StringToInteger(tm2[1])){
         closeneed = true;
         comm = comm + "   !!!! "+Hour()+" : "+Minute()+"\n";
      }
   }
   
   
   if(closeneed && OrdersTotal()>0){
      CloseBuy(); CloseSell();
   }
   
   if(tradetime && Bid>Dmax && SellOrders()==0 && BuyOrders()==0) // && BarT!=TempT
     {
      int ticket=OrderSend(NULL,OP_BUY,Lot,Ask,30,Ask-StLoss*_Point,Ask+TProf*_Point,NULL,Magik,0,clrBlue);
      if(ticket<0)
        {
         Print("OrderSend error #",GetLastError());
        }
      BarT=TempT;
     }
   if(tradetime && Ask<Dmin && BuyOrders()==0 && SellOrders()==0) // BarT!=TempT
     {
      int ticket=OrderSend(NULL,OP_SELL,Lot,Bid,30,Bid+StLoss*_Point,Ask-TProf*_Point,NULL,Magik,0,clrRed);
      if(ticket<0)
        {
         Print("OrderSend error #",GetLastError());
        }
      BarT=TempT;
     }
//--- Trailing Stop operation
   for(int cni=0;cni<total;cni++)
     {
      if(!OrderSelect(cni,SELECT_BY_POS,MODE_TRADES))
         continue;
      if(OrderMagicNumber()==Magik)
        {
         if(OrderType()==OP_BUY)
           {
            if(Bid-OrderOpenPrice()>_Point*StLoss)
              {
               if(OrderStopLoss()<OrderOpenPrice())
                 {
                  //--- modify order and exit
                  if(!OrderModify(OrderTicket(),OrderOpenPrice(),Bid-_Point*StLoss,OrderTakeProfit(),0,clrBlue))
                     Print("OrderModify error ",GetLastError());
                  return;
                 }
              }
           }
         if(OrderType()==OP_SELL)
           {
            if((OrderOpenPrice()-Ask)>_Point*StLoss)
              {
               if(OrderStopLoss()>OrderOpenPrice())
                 {
                  //--- modify order and exit
                  if(!OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*StLoss,OrderTakeProfit(),0,clrRed))
                     Print("OrderModify error ",GetLastError());
                  return;
                 }
              }
           }
        }
     }
     
     
   Comment(comm);
     
  }
//+------------------------------------------------------------------+
int BuyOrders()
 {
  int co,t;
  for(co=0; co<OrdersTotal(); co++)
   {
    if(OrderSelect(co,SELECT_BY_POS))
     if(OrderSymbol()==Symbol())
      if(OrderMagicNumber()==Magik)
       {
        if(OrderType()==OP_BUY) t++;
       }
   }
  return(t); 
 }

int SellOrders()
 {
  int cp,t;
  for(cp=0; cp<OrdersTotal(); cp++)
   {
    if(OrderSelect(cp,SELECT_BY_POS))
     if(OrderSymbol()==Symbol())
      if(OrderMagicNumber()==Magik)
       {
        if(OrderType()==OP_SELL) t++;
       }
   }
  return(t); 
 }
 
void CloseSell()
 {
  int t;
  while(SellOrders()>0)
   {
    for(int c=0; c<=OrdersTotal();c++)
     {
      if(OrderSelect(c,SELECT_BY_POS, MODE_TRADES))
       if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magik)//
        {              
         if(OrderType()==OP_SELL)
          {
           for(t=0; t<=5; t++)
            {
             RefreshRates();
             int ticket=OrderClose(OrderTicket(),OrderLots(),Ask,10,Red);
             int e=GetLastError();
             if(e==0) break; else Print("error close Sell : "+e);
            }
          }
        }
     }
   }
  return;
 }

void CloseBuy()
 {
  int t;
  while(BuyOrders()>0)
   {
    for(int c=0; c<=OrdersTotal();c++)
     {
      if(OrderSelect(c,SELECT_BY_POS, MODE_TRADES))
       if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magik) //
        {              
         if(OrderType()==OP_BUY)
          {
           for(t=0; t<=5; t++)
            {
             RefreshRates();
             int ticket=OrderClose(OrderTicket(),OrderLots(),Bid,10,Red);
             int e=GetLastError();
             if(e==0) break; else Print("error close Sell : "+e);
            }
          }
        }
     }
   }
  return;
 }